%if 0%{?rhel} && 0%{?rhel} <= 5
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_version: %global python_version %(%{__python} -c "import sys ; print sys.version[:3]")}
%endif


%if 0%{?fedora} || 0%{?rhel} > 6
%global with_python3 1
%{!?__python3: %global __python3 python3}
%{!?python3_version: %global python3_version %(%{__python3} -c "import sys; sys.stdout.write(sys.version[:3])")}
%endif


%global upstream_name nose
%global maj_ver 1.1

# Enable building without docs to avoid a circular dependency between this and python-sphinx
%global with_docs 1

Name:           python-nose1.1
Version:        1.1.2
Release:        4%{?dist}
Summary:        Discovery-based unittest extension for Python

Group:          Development/Languages
License:        LGPLv2+ and Public Domain
URL:            http://somethingaboutorange.com/mrl/projects/nose/
# Upstream's tarball was created with a version of tar that creates unsupported
# headers.  RHEL5's tar cannot handle those.  Since this package may be built
# on RHEL5 I've retarred the file like this on a Fedora 14 box:
# wget http://pypi.python.org/packages/source/n/nose/nose-1.1.2.tar.gz
# tar -xpzf nose-1.1.2.tar.gz
# tar -cpzf nose-1.1.2.tar.gz nose-1.1.2
# mv nose-1.1.2.tar.gz.new nose-1.1.2.tar.gz
Source0: nose-1.1.2.tar.gz
Source1: README.fedora
# Submitted upstream: http://code.google.com/p/python-nose/issues/detail?id=421
Patch1: nose-manpage.patch
# For using the older python-coverage found on RHEL6
Patch2: nose-coverage-0.3.4.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  python2-devel
%if 0%{?with_python3}
BuildRequires: python3-devel
BuildRequires: python3-setuptools
BuildRequires: python3-coverage >= 3.4-1
%endif
BuildRequires: python-setuptools
BuildRequires: dos2unix
BuildRequires:  python-coverage
Requires:       python-setuptools

%description
nose extends the test loading and running features of unittest, making
it easier to write, find and run tests.

By default, nose will run tests in files or directories under the
current working directory whose names include "test" or "Test" at a
word boundary (like "test_this" or "functional_test" or "TestClass"
but not "libtest"). Test output is similar to that of unittest, but
also includes captured stdout output from failing tests, for easy
print-style debugging.

These features, and many more, are customizable through the use of
plugins. Plugins included with nose provide support for doctest, code
coverage and profiling, flexible attribute-based test selection,
output capture and more.

This package contains a newer version of nose than was originally included for
use by packages that need the features and API made available since the
original package release.

%package docs
Summary:        Nose Documentation
Group:          Documentation
BuildRequires:  python-sphinx
Requires:       python-nose1.1 = %{version}-%{release}

%description docs
Documentation for Nose

%if 0%{?with_python3}
%package -n python3-%{upstream_name}%{maj_ver}
Summary:        Discovery-based unittest extension for Python3
Group:          Development/Languages
Requires:       python3-setuptools

%description -n python3-%{upstream_name}%{maj_ver}
nose extends the test loading and running features of unittest, making
it easier to write, find and run tests.

By default, nose will run tests in files or directories under the
current working directory whose names include "test" or "Test" at a
word boundary (like "test_this" or "functional_test" or "TestClass"
but not "libtest"). Test output is similar to that of unittest, but
also includes captured stdout output from failing tests, for easy
print-style debugging.

These features, and many more, are customizable through the use of
plugins. Plugins included with nose provide support for doctest, code
coverage and profiling, flexible attribute-based test selection,
output capture and more.

This package installs the nose module and nosetests3 program that can discover
python3 unittests.
%endif # with_python3

%prep
%setup -q -n %{upstream_name}-%{version}
%patch1 -p1 -b .manp
%if 0%{?rhel} && 0%{?rhel} <= 6
%patch2 -p1 -b .cvrge
%endif # with rhel <= 6

dos2unix examples/attrib_plugin.py

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif # with_python3

cp %{SOURCE1} .

%build
%{__python} setup.py bdist_egg

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py bdist_egg
popd
%endif # with_python3

%install
rm -rf %{buildroot}
# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
%if 0%{?with_python3}
pushd %{py3dir}
mkdir -p %{buildroot}%{python3_sitelib}
easy_install-%{python3_version} -m --prefix %{buildroot}%{_usr} dist/*.egg
find %{buildroot}%{python3_sitelib} -type f -exec chmod 0644 \{\} \;
rm %{buildroot}%{_bindir}/nosetests

mkdir -m 0755 -p %{buildroot}%{_mandir}/man1/
mv %{buildroot}%{_bindir}/nosetests-%{python3_version} %{buildroot}%{_bindir}/nosetests%{maj_ver}-%{python3_version}
install -m 0755 -d  %{buildroot}%{_mandir}/man1/
install -m 0644 nosetests.1 %{buildroot}%{_mandir}/man1/nosetests%{maj_ver}-%{python3_version}.1
rm -rf %{buildroot}%{python3_sitelib}/nose*egg/man
popd
%endif # with_python3

mkdir -p %{buildroot}%{python_sitelib}
easy_install -m --prefix %{buildroot}%{_usr} dist/*.egg
find %{buildroot}%{python_sitelib} -type f -exec chmod 0644 \{\} \;

mv %{buildroot}%{_bindir}/nosetests %{buildroot}%{_bindir}/nosetests%{maj_ver}
mv %{buildroot}%{_bindir}/nosetests-%{python_version} %{buildroot}%{_bindir}/nosetests%{maj_ver}-%{python_version}
install -m 0755 -d  %{buildroot}%{_mandir}/man1/
install -m 0644 nosetests.1 %{buildroot}%{_mandir}/man1/nosetests%{maj_ver}.1
rm -rf %{buildroot}%{python_sitelib}/nose*egg/man

%if 0%{?with_docs}
pushd doc
make html
rm -rf .build/html/.buildinfo .build/html/_sources
mv .build/html ..
rm -rf .build
popd
%endif # with_docs
cp -a doc reST
rm -rf reST/.static reST/.templates


%check
#%{__python} selftest.py

%if 0%{?with_python3}
pushd %{py3dir}
export PYTHONPATH=`pwd`/build/lib
%{__python3} setup.py build_tests
%{__python3} selftest.py
popd
%endif # with_python3

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc AUTHORS CHANGELOG lgpl.txt NEWS README.txt README.fedora
%{_bindir}/nosetests%{maj_ver}
%{_bindir}/nosetests%{maj_ver}-%{python_version}
%{_mandir}/man1/nosetests%{maj_ver}.1.gz
%{python_sitelib}/*

%if 0%{?with_python3}
%files -n python3-%{upstream_name}%{maj_ver}
%defattr(-,root,root,-)
%doc AUTHORS CHANGELOG lgpl.txt NEWS README.txt README.fedora
%{_bindir}/nosetests%{maj_ver}-%{python3_version}
%{_mandir}/man1/nosetests%{maj_ver}-%{python3_version}.1.gz
%{python3_sitelib}/*
%endif

%files docs
%defattr(-,root,root,-)
%doc reST examples
%if 0%{?with_docs}
%doc html
%endif # with_docs

%changelog
* Mon Nov 28 2011 Pádraig Brady <P@draigBrady.com> - 1.1.2-4
- Have the docs package depend on the specific version of python-nose1.1
- Change python3-nose package name to python3-nose1.1
- Only apply coverage patch on rhel <= 6 to allow builds elsewhere
- Ensure __python3 is defined to allow builds on F15 at least

* Sat Nov 19 2011 Toshio Kuratomi <toshio@fedoraproject.org> - 1.1.2-3
- Add dep between docs package and main package
- Remove RPM_OPT_FLAGS, unnecessary with noarch package
- Add README.fedora

* Fri Nov 18 2011 Toshio Kuratomi <toshio@fedoraproject.org> - 1.1.2-2
- Forward compat package for nose

* Mon Aug 1 2011 Toshio Kuratomi <toshio@fedoraproject.org> - 1.1.2-1
- Upstream bugfix release

* Wed Jul 27 2011 Toshio Kuratomi <toshio@fedoraproject.org> - 1.1.1-1
- Upstream bugfix release

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Dec 26 2010 Toshio Kuratomi <toshio@fedoraproject.org> - 1.0.0-1
- Update to 1.0.0
- Create the docs subpackage for text docs even if we don't create the html docs.
- Make python3 subpackage

* Tue Dec 7 2010 Toshio Kuratomi <toshio@fedoraproject.org> - 0.11.4-2
- Fix FTBFS with newer coverage

* Thu Oct 21 2010 Luke Macken <lmacken@redhat.com> - 0.11.4-1
- Update to 0.11.4 (#3630722)

* Wed Jul 21 2010 David Malcolm <dmalcolm@redhat.com> - 0.11.3-5
- add support for building without docs, to avoid a circular build-time
dependency between this and python-sphinx; disable docs subpackage for now
- add (apparently) missing BR on python-coverage (appears to be needed
for %%check)
- cherrypick upstream compatibility fixes for 2.7

* Wed Jul 21 2010 David Malcolm <dmalcolm@redhat.com> - 0.11.3-4
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Thu May 20 2010 Luke Macken <lmacken@redhat.com> - 0.11.3-3
- Update URL to http://code.google.com/p/python-nose/
- Align description to reflect that in setup.py
- Create a docs subpackage containing HTML & reST documentation
- Thanks to Gareth Armstrong at HP for the patch

* Thu May 06 2010 Luke Macken <lmacken@redhat.com> - 0.11.3-2
- Don't hardcode the python version

* Thu May 06 2010 Luke Macken <lmacken@redhat.com> - 0.11.3-1
- Update to 0.11.3
- Enable the self tests

* Mon Oct 05 2009 Luke Macken <lmacken@redhat.com> - 0.11.1-2
- Include the new nosetests-2.6 script as well

* Mon Oct 05 2009 Luke Macken <lmacken@redhat.com> - 0.11.1-1
- Update to 0.11.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.10.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.10.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Nov 29 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 0.10.4-1
- Update to 0.10.4 to fix 2.6 issues

* Sat Nov 29 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 0.10.3-2
- Rebuild for Python 2.6

* Sat Aug 02 2008 Luke Macken <lmacken@redhat.com> 0.10.3-1
- Update to 0.10.3

* Thu Feb 28 2008 Luke Macken <lmacken@redhat.com> 0.10.1-1
- Update to 0.10.1

* Mon Dec  3 2007 Luke Macken <lmacken@redhat.com> 0.10.0-2
- Add python-setuptools to Requires (Bug #408491)

* Tue Nov 27 2007 Luke Macken <lmacken@redhat.com> 0.10.0-1
- 0.10.0

* Sun Sep  2 2007 Luke Macken <lmacken@redhat.com> 0.10.0-0.3.b1
- Update for python-setuptools changes in rawhide

* Tue Aug 21 2007 Luke Macken <lmacken@redhat.com> 0.10.0-0.2.b1
- 0.10.0b1
- Update license tag to LGPLv2

* Fri Jun 20 2007 Luke Macken <lmacken@redhat.com> 0.10.0-0.1.a2
- 0.10.0a2

* Sat Jun  2 2007 Luke Macken <lmacken@redhat.com> 0.9.3-1
- Latest upstream release
- Remove python-nose-0.9.2-mandir.patch

* Sat Mar  3 2007 Luke Macken <lmacken@redhat.com> 0.9.2-1
- Add nosetests(1) manpage, and python-nose-0.9.2-mandir.patch to put it in
  the correct location.
- 0.9.2

* Sat Dec  9 2006 Luke Macken <lmacken@redhat.com> 0.9.1-2
- Rebuild for python 2.5

* Fri Nov 24 2006 Luke Macken <lmacken@redhat.com> 0.9.1-1
- 0.9.1

* Fri Sep  8 2006 Luke Macken <lmacken@redhat.com> 0.9.0-1
- 0.9.0

* Wed Apr 19 2006 Ignacio Vazquez-Abrams <ivazquez@ivazquez.net> 0.8.7.2-1
- Initial RPM release
